close all; clear all; clc;
%nacitanie dat do pomocnej matice inpcassl
[fname,pname] = uigetfile('*.dat','input of data (ASCII)');
inpcassl = dlmread(fname);

%rozdelenie do dvoch jednostlpcovych matic: cas a slapy
cas = inpcassl(:,1); slap = inpcassl(:,2);

%zistenie poctu nacitanych dat 
m = numel(cas);

%oznamenie poctu nacitanych dat uzivatelovi
%tvorba retazca s kombinaciou funkcie int2str(m) a textu
%s2 = 'pocet udajov: ' + s;
s = ['pocet udajov: ' int2str(m)];
msgbox(s,'message');

%zobrazenie grafu povodnych nacitanych hodnot
plot(cas, slap,'-r'); 
xlabel('cas [hod] - desatinny tvar','FontSize',10); ylabel('slapy [10-9 ms-2]','FontSize',10); title('povodne udaje');

%kontrola dat na vyskocene hodnoty a ich naprava
for i=1:m % i sa meni od 1 po m
  if slap(i) == 0.1
      %jedoduche generovanie novej hodnoty namiesto vyskocenej (priemeru zo susednych)
      slap(i) = (slap(i-1)+slap(i+1))/2;
  end; %uzavretie podmienky if
end;  %uzavretie cyklu for i=1:m

%zobrazenie grafu opravenych hodnot
figure, plot(cas, slap,'-b');
xlabel('cas [hod] - desatinny tvar','FontSize',10); ylabel('slapy [10-9 ms-2]','FontSize',10); title('opravene udaje');

%zadanie stupna polynomu cez okno
%text nad dialogovy riadok a nazov okna
prompti = {'stupen polynomu (1 - 4)'}; titlei = 'zadaj';
%inicializacna hodnota
n_polynom = 2;
%vypisanie obsahu riadku (pracuje sa s jednym riadkom)
linesi = 1; defi = {num2str(n_polynom)};
%ziskanie odpovede po zmene uzivatelom, funkcia inputglg
answer = inputdlg(prompti,titlei,linesi,defi);
%prevedenie odpovede na numericku hodnotu
opergstr1 = answer(1); n_polynom = str2double(opergstr1);

%samotne fitovanie polynomu
koef_polynom = polyfit(cas,slap,n_polynom);

%vypocet fitujucej polynomickej funkcie
for j = 1:m
    switch n_polynom
    case 1 
    fit(j) = koef_polynom(1)*cas(j) + koef_polynom(2); 
    case 2
    fit(j) = koef_polynom(1)*cas(j)^2 + koef_polynom(2)*cas(j) + koef_polynom(3);
    case 3
    fit(j) = koef_polynom(1)*cas(j)^3 + koef_polynom(2)*cas(j)^2 + koef_polynom(3)*cas(j) + koef_polynom(4);
    case 4
    fit(j) = koef_polynom(1)*cas(j)^4 + koef_polynom(2)*cas(j)^3 + koef_polynom(3)*cas(j)^2 + koef_polynom(4)*cas(j) + koef_polynom(5); 
    end;
end;

%vysledny graf
figure, plot(cas,slap,'-r');
hold on;
plot(cas,fit); 
xlabel('cas [hod] - desatinny tvar','FontSize',10); ylabel('slapy [10-9 ms-2]','FontSize',10);
legend('opravene udaje',['polyn. fit stupna: ' int2str(n_polynom)]); title('vysledok');

